//! zinc
library ShockDrain {
    constant integer ABILITY = 'ANdr';
    constant integer DUMMY   = 'nogl';
    constant integer DUMMY_ABILITY = 'ACsh';

    struct str extends array {
        static thistype Max = 0;
        unit   caster;
        widget target;
    }

    function onInit() {
        trigger cast = CreateTrigger(), trig = CreateTrigger();
        boolexpr cond = Condition(function() -> boolean { return GetSpellAbilityId() == ABILITY; } );
        integer i = 0;
        do {
            TriggerRegisterPlayerUnitEvent(cast, Player(i), EVENT_PLAYER_UNIT_SPELL_EFFECT, null);
            TriggerRegisterPlayerUnitEvent(trig, Player(i), EVENT_PLAYER_UNIT_SPELL_FINISH, null);
            i = i + 1;
        } while (i < 16);
        TriggerAddCondition(cast, cond);
        TriggerAddCondition(trig, cond);
        TriggerAddAction(cast,
            function() {
                str.Max.caster = GetTriggerUnit();
                str.Max.target = GetSpellTargetUnit();
                str.Max = str.Max + 1;
            }
        );
        TriggerAddAction(trig,
            function() {
                handle h = GetTriggerUnit();
                str this = 0;
                real x, y;
                unit dummy;
                while (h != this.caster) { this = this + 1; }
                x = GetWidgetX(this.caster), y = GetWidgetY(this.caster);
                dummy = CreateUnit(GetOwningPlayer(this.caster), DUMMY, x, y,
                    Atan2(GetWidgetY(this.target) - y, GetWidgetX(this.target) - x) * 57.296);
                UnitApplyTimedLife(dummy, 'BTLF', 1.);
                SetUnitExploded(dummy, true);
                SetUnitAbilityLevel(dummy, DUMMY_ABILITY, GetUnitAbilityLevel(this.caster, ABILITY));
                IssueTargetOrderById(dummy, 852125 /*shockwave*/, this.target);
                str.Max = str.Max - 1;
                this.caster = str.Max.caster;
                this.target = str.Max.target;
                h = null; dummy = null;
            }
        );
        cast = null; trig = null; cond = null;
    }
}
//! endzinc
